/* 	$Id: reduce_scat.c,v 1.1 1993/11/10 01:13:04 lusk Exp $	 */

#ifndef lint
static char vcid[] = "$Id: reduce_scat.c,v 1.1 1993/11/10 01:13:04 lusk Exp $";
#endif /* lint */

#include <mpi.h>
#include "coll.h"

/*@

MPI_Reduce_scatter - 

@*/
MPI_Reduce_scatter ( sendbuf, recvbuf, recvcnts, datatype, op, comm )
void             *sendbuf;
void             *recvbuf;
int              *recvcnts;
MPI_Datatype      datatype;
void            (*op)();
MPI_Communicator  comm;
{
  int rank, size, i, count=0, extent;
  int *displs;
  void *buffer;

  /* Check for invalid arguments */
  if ( (comm == (MPI_Communicator)0) ||
       (comm->comm_type == MPIR_INTER) ) 
    return (MPI_SUCCESS); 

  /* Determine the "count" of items to reduce and set the displacements*/
  MPI_Extent ( datatype, &extent );
  MPI_Comm_size (comm, &size);
  MPI_Comm_rank (comm, &rank);
  buffer = (void *)MALLOC(extent*count);
  displs = (int *)MALLOC(size*sizeof(int));
  for (i=0;i<size;i++) {
    count += recvcnts[i];
    displs[i] = i*extent;
  }

  /* Reduce to 0, then bcast */
  MPI_REDUCE ( sendbuf, buffer, count, datatype, op, 0, comm );
  MPI_SCATTERV ( buffer, displs, recvcnts, datatype, recvbuf, recvcnts[rank],
		 datatype, datatype, 0, comm );
  
  FREE(buffer); FREE(displs);
  return (MPI_SUCCESS);
}
