/*
 *  $Id: map_graph.c,v 1.4 1993/11/12 12:35:46 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

/*@

MPI_Map_graph - map process to graph topology information

@*/
int MPI_Map_graph ( comm_old, nnodes, index, edges, newrank )
MPI_Comm comm_old;
int              nnodes;
int             *index;
int             *edges;
int             *newrank;
{
  int i;
  int nranks;
  int rank;

  /* Check for valid arguments */
  if ( (comm_old == (MPI_Comm)0 ) ||
       (nnodes   <  1) ||
       (newrank  == (int *)0) ||
       (index    == (int *)0) ||
       (edges    == (int *)0) )
    return (MPI_SUCCESS);
  
  /* Am I in this topology? */
  MPI_Comm_rank ( comm_old, &rank );
  if ( rank < nnodes )
    (*newrank) = rank;
  else
    (*newrank) = MPI_UNDEFINED;

  return (MPI_SUCCESS);
}
